#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <qdos.h>
#include <qptr.h>
#include "spv.h"

char _prog_name[] = "vspv";

short ShowPic(PICVIEW *ppv, WM_wsiz_t *wdef)
{
    short done = 0;
    
    switch(ppv->act)
    {
      case 27:
	done = 1; 
	break;
      case 0xd9:                    /* A-DOWN */
	ppv->cy = ppv->cy + ppv->my;
	break;
      case 0xd8:                    /* DOWN */
      case 0xdc:
	ppv->cy = ppv->cy + ppv->my/8;
	break;
      case 0xd1:                    /* A-UP */
	ppv->cy = ppv->cy - ppv->my;
	break;
      case 0xd0:                    /* UP */
      case 0xd4:
	ppv->cy = ppv->cy - ppv->my/8;
	break;
      case 0xc9:                    /* A-RIGHT */
	ppv->cx = ppv->cx + ppv->mx;
	break;
      case 0xc8:                    /* RIGHT */
      case 0xcc:
	ppv->cx = ppv->cx + ppv->mx/8;
	break;
      case 0xc1:                    /* A-LEFT */
	ppv->cx = ppv->cx - ppv->mx;
	break;
      case 0xc0:                    /* LEFT */
      case 0xc4:
	ppv->cx = ppv->cx - ppv->mx/8;
	break;
    }	    
    if(ppv->cx < 0) ppv->cx = 0;
    if(ppv->cx > ppv->lx) ppv->cx = ppv->lx;
    if(ppv->cy < 0) ppv->cy = 0;
    if(ppv->cy > ppv->ly) ppv->cy = ppv->ly;

    if(ppv->cx != ppv->xx || ppv->cy != ppv->yy)
    {
	iop_rspw(ppv->chan, -1, wdef, 
		 ppv->cx, ppv->cy, 1, ppv->picbuf);
	ppv->xx = ppv->cx;
	ppv->yy = ppv->cy;
    }
    return done;
}

int main (int ac, char **av)
{
    int n;
    char *sp;
    short nc;
    int ch,rn = -15;
    short mdef[4];
    short wdef[4];
    unsigned char buf[1];
    PICVIEW pv;
    
    sp = *(av + 1);
    nc = *((short *) sp)++;

    sp += nc << 2;

    if (nc = *((short *) sp)++)
    {
	struct qdirect qd;
	
	char *q;
	q = malloc(nc + 1);
	memcpy(q, sp, nc);
	*(q+nc) = 0;
  	ch = rn = io_open (q, 0);
	if(ch > 0)
	{
	    fs_headr(ch, -1, &qd, sizeof(qd));
	    pv.picbuf = calloc(4+qd.d_length,1);
	    if(pv.picbuf)
	    {	    
		pv.ph = (PICHEAD *)((char *)pv.picbuf + 4);
		rn = fs_load(ch, (void *)pv.ph, qd.d_length);
		if(rn >= 0 && pv.ph->flag != 0x4afc)
		{
		    rn = -4;
		}
		
	    }
	    else
	    {
		rn = -3;
	    }
	    io_close(ch);
	}
	if(rn >= 0)
	{
	    short done;
	    short mymode=-1, mymon=-1, newmode;

	    newmode = (pv.ph->mode >> 8);
	    mt_dmode(&mymode, &mymon);
	    if(mymode != newmode)
	    {
		mt_dmode(&newmode, &mymon);
	    }

	    pv.chan = io_open("con", 0);
	    iop_flim(pv.chan, -1, (WM_wsiz_t *) wdef);
	    pv.wwid = wdef[0] - BXOFF;
	    pv.whgt = wdef[1] - BYOFF;

	    if(pv.ph->xpix < pv.wwid)
	    {
		pv.wwid = pv.ph->xpix;
	    }

	    if(pv.ph->ypix < pv.whgt)
	    {
		pv.whgt = pv.ph->ypix;
	    }

	    mdef[0] = pv.wwid+BXOFF;    
	    mdef[1] = pv.whgt+BYOFF;
	    mdef[2] = (wdef[0] - mdef[0])/2;
	    mdef[3] = (wdef[1] - mdef[1])/2;

	    sd_wdef(pv.chan, -1, 0, 0, (struct QLRECT *)mdef);
	    sd_bordr(pv.chan, -1, 2, 1);
	    sd_clear(pv.chan, -1);
	    wdef[0] = pv.wwid;
	    wdef[1] = pv.whgt;
	    wdef[2] = wdef[3] = 0;

	    pv.cx = pv.cy = 0;
	    pv.xx = pv.yy = -1;
	    pv.act = 0;
	    pv.ly = pv.ph->ypix - pv.whgt;
	    pv.lx = pv.ph->xpix - pv.wwid;
	    pv.mx = ((pv.wwid * 8 /10) + 7) & ~7;
	    pv.my = ((pv.whgt * 8 /10) + 7) & ~7;	

	    ShowPic(&pv, (WM_wsiz_t *) wdef);

	    for(done = 0; !done; )
	    {
		if ((n = io_fbyte(pv.chan, -1, (char *)buf)) >= 0)
		{
		    pv.act = *buf;
		    done = ShowPic(&pv, (WM_wsiz_t *) wdef);
		}
		else
		    break;
	    }
	    io_close(pv.chan);
	    rn = 0;
   	    if(mymode != newmode)
	    {
		mt_dmode(&mymode, &mymon);
	    }
	}
    }
    else
    {                       
	ut_mtext(0, (struct QLSTR*)"\000\025usage: vspv filename\n");
    }
    return rn;
}
int (*_Cstart) (int, char **) = main;
